.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE DateTime.inc

;.CONST
;
;    ALIGN 8
;    qwDaysAsFileTime         QWORD 864000000000
;    qwHoursAsFileTime        QWORD  36000000000
;    qwMinutesAsFileTime      QWORD    600000000
;    qwSecondsAsFileTime      QWORD     10000000
;    qwMillisecondsAsFileTime QWORD        10000

.CODE

DateDiff PROC pszInterval:PTR BYTE, pdt1:PTR DATETIME, pdt2:PTR DATETIME, plNumber:PTR SDWORD

    ; pszInterval  = pointer to BYTE, interval type, "d" = days, "h" = hours, "m" = minutes, "s" = seconds
    ; pdt1        = pointer to a DATETIME
    ; pdt2        = pointer to a DATETIME
    ; plNumber    = pointer to SDWORD, number of intervals
    ;
    ; Returns eax = 0 if no error, -1 if invalid interval
    ;

    LOCAL cwOld:WORD
    LOCAL cwNew:WORD

    mov ecx, pdt1
    mov edx, pdt2

    finit                   ; initialize FPU

    ;Subtract Date1 from Date2 to calculate the difference
    fild QWORD PTR [edx] ; Date 2
    fild QWORD PTR [ecx] ; Date 1
    fsub

convert:

    mov eax, pszInterval
    mov edx, plNumber

    .IF BYTE PTR [eax] == "d"
        ; convert difference to days
        fild qwDaysAsFileTime
    .ELSEIF BYTE PTR [eax] == "h"
        ; convert difference to hours
        fild qwHoursAsFileTime
    .ELSEIF BYTE PTR [eax] == "m"
        ; convert difference to minutes
        fild qwMinutesAsFileTime
    .ELSEIF BYTE PTR [eax] == "s"
        ; convert difference to seconds
        fild qwSecondsAsFileTime
    .ELSE
        ffree st(0)
        fwait
        mov SDWORD PTR [edx], 0
        mov eax, -1
        jmp @F
    .ENDIF

    fdiv

    ; set rounding to truncate, we don't want any rounding
    fstcw cwOld               ; store FPU control word to cwOld
    mov ax, cwOld             ; copy cwOld to ax
    or ax, 0C00h              ; modify ax for rounding = truncate
    mov cwNew, ax             ; copy ax to cwNew
    fldcw cwNew               ; load cwNew to FPU control word, rounding = truncate

    ; truncate the result to an integer
    fistp SDWORD PTR [edx]

    ; set rounding to original mode
    fldcw cwOld               ; load original control word, set original rounding

    xor eax, eax

  @@:
    ret

DateDiff ENDP


END
